[![pipeline status](https://gitlab.com/tom79/mastalab/badges/develop/pipeline.svg)](https://gitlab.com/tom79/mastalab/commits/develop)

## Mastalab is a multi-accounts client for Mastodon [![License: GPL v3](https://img.shields.io/badge/License-GPL%20v3-blue.svg)](https://www.gnu.org/licenses/gpl-3.0) [<img alt="Donate using Liberapay" src="https://liberapay.com/assets/widgets/donate.svg"/>](https://liberapay.com/tom79/donate)

The number of libraries is minimized and it does not use tracking tools. The source code is free (GPLv3). Any help would be greatly appreciated to fix spelling or for any other suggestions.

[<img alt='Get it on Google Play' src='https://play.google.com/intl/en_us/badges/images/generic/en_badge_web_generic.png' height="80"/>](https://play.google.com/store/apps/details?id=fr.gouv.etalab.mastodon)
[<img alt='Get it on Google Play' src='https://gitlab.com/fdroid/artwork/raw/master/badge/get-it-on.png' height="80"/>](https://f-droid.org/app/fr.gouv.etalab.mastodon)



[WIKI](https://gitlab.com/tom79/mastalab/wikis/home)

[Release notes](https://gitlab.com/tom79/mastalab/tags)



### Features

**Multi-accounts management**

* Add accounts from different instances
* Switch from one account to another by a simple click


**Timelines**

* Federated / Local / Home
* Switch from one timeline to another by using the menu or by swiping the screen.
* Clicks on toots display the related conversations (context)
* Clicks on mentioned accounts display details about these accounts
* Clicks on hashtags display toots containing this hashtags


**Actions on toots**

* Mute an account related to a toot
* Block an account related to a toot
* Report inappropriate toots to administrators
* Add/Remove a toot from favourites
* Boost/Unboost toots
* Copy the content of a toot
* Download media
* Translation of toots by a simple click (via the Yandex API)


**Write a toot**

* Add media
* Change the visibility of the toot 
* Mention accounts in toots with autocompletion (@ + 2 characters)
* Mark the content as sensitive
* Add spoilers
* Toots which have not been sent are saved (drafts) - can be disabled in settings
* Drafts can be edited/deleted/scheduled


**Scheduled toots**

* Can be edited/deleted/scheduled at another date as long as they have not been sent.


**Interaction with accounts**

* Follow/Unfollow/Block/Unblock/Mute/Unmute
* Display details of accounts
* Authorize/Reject follow requests (for locked accounts)


**Searches**
* A top bar allows to make researches for accounts/tags/toots
* A click on a tag displays toots containing this tag


**Network optimization**

* Load of media: Automatic/WIFI only/Ask
* Customization of the number of toots/accounts per load


**Notifications**

* Notifications for new toots on the home page (could be disabled in settings)
* Notifications for new events (could be disabled or filtered in settings)


**Built-in browser**

* Full screen videos
* Disable JavaScript (default: enabled)
* Disable third-party cookies (default: disabled)
* Disable the built-in browser in settings


Developer: [@tom79](https://mastodon.social/@tom79)

